if select(5, GetAddOnInfo("PitBull4_" .. (debugstack():match("[o%.][d%.][u%.]les\\(.-)\\") or ""))) ~= "MISSING" then return end

local PitBull4 = _G.PitBull4
if not PitBull4 then
	error("PitBull4_CastingUnfader requires PitBull4")
end

local PitBull4_CastingUnfader = PitBull4:NewModule("CastingUnfader","AceEvent-3.0")

PitBull4_CastingUnfader:SetModuleType("fader")
PitBull4_CastingUnfader:SetName("Casting unfader")
PitBull4_CastingUnfader:SetDescription("Change the opacity of the unit frame when the unit is casting.")
PitBull4_CastingUnfader:SetDefaults({
	enabled = false,
	casting_oppacity = 0.75,
})

function PitBull4_CastingUnfader:OnEnable()
  self:RegisterEvent("UNIT_SPELLCAST_START")
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
	self:RegisterEvent("UNIT_SPELLCAST_STOP")
	self:RegisterEvent("UNIT_SPELLCAST_FAILED")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
	self:RegisterEvent("UNIT_SPELLCAST_DELAYED")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
end

function PitBull4_CastingUnfader:CastHappened(event, unit)
  self:UpdateForUnitID(unit)
end

PitBull4_CastingUnfader.UNIT_SPELLCAST_START          = PitBull4_CastingUnfader.CastHappened
PitBull4_CastingUnfader.UNIT_SPELLCAST_CHANNEL_START  = PitBull4_CastingUnfader.CastHappened
PitBull4_CastingUnfader.UNIT_SPELLCAST_STOP           = PitBull4_CastingUnfader.CastHappened
PitBull4_CastingUnfader.UNIT_SPELLCAST_FAILED         = PitBull4_CastingUnfader.CastHappened
PitBull4_CastingUnfader.UNIT_SPELLCAST_INTERRUPTED    = PitBull4_CastingUnfader.CastHappened
PitBull4_CastingUnfader.UNIT_SPELLCAST_SUCCEEDED      = PitBull4_CastingUnfader.CastHappened
PitBull4_CastingUnfader.UNIT_SPELLCAST_DELAYED        = PitBull4_CastingUnfader.CastHappened
PitBull4_CastingUnfader.UNIT_SPELLCAST_CHANNEL_UPDATE = PitBull4_CastingUnfader.CastHappened
PitBull4_CastingUnfader.UNIT_SPELLCAST_CHANNEL_STOP   = PitBull4_CastingUnfader.CastHappened


function PitBull4_CastingUnfader:GetOpacity(frame)
  local unit = frame.unit
  
  if not unit then return end
  if not UnitCastingInfo(unit) then return end

  local layout_db = self:GetLayoutDB(frame)
  return max(frame:GetAlpha(), layout_db.casting_oppacity), 100
end

PitBull4_CastingUnfader:SetLayoutOptionsFunction(function(self)
	return 'casting_oppacity', {
		type = 'range',
		name = "Casting opacity",
		desc = "The opacity to display if the unit is casting.",
		min = 0,
		max = 1,
		isPercent = true,
		get = function(info)
			local db = PitBull4.Options.GetLayoutDB(self)

			return db.casting_oppacity
		end,
		set = function(info, value)
			local db = PitBull4.Options.GetLayoutDB(self)

			db.casting_oppacity = value

			PitBull4.Options.UpdateFrames()
			PitBull4:RecheckAllOpacities()
		end,
		step = 0.01,
		bigStep = 0.05,
	}
end)
